Package com.collibra.dgc.core.api.model.assignment

# Interface AssignedCharacteristicTypeReference

All Superinterfaces:
  `Serializable`

public interface AssignedCharacteristicTypeReference extends Serializable
Represents a reference to an assigned Characteristic Type, as well as its assignment properties such as cardinality etc.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getAssignedResourcePublicId()`
  Returns the public id of the assigned Characteristic Type.
  `NamedResourceReference`
  `getAssignedResourceReference()`
  Returns the reference to the assigned Characteristic Type.
  `UUID`
  `getId()`
  Returns the unique identifier of the Assigned Characteristic Type Reference.
  `List<UUID>`
  `getMatchingLegTypesIds()`
  Returns the list of `id`s that match the legs of the complex relation or null if this reference is not a `ComplexRelationType`.
  `Integer`
  `getMaximumOccurrences()`
  Returns how many times an assigned Characteristic may be added at most to the Resource.
  `int`
  `getMinimumOccurrences()`
  Returns how many times the assigned Characteristic must at the minimum be added to the Resource.
  `RelationTypeDirection`
  `getRelationTypeDirection()`
  Returns the direction of the Relation Type or null when this reference isn't a reference to a Relation Type.
  `NamedResourceReference`
  `getRelationTypeRestriction()`
  Returns the restriction on the target of the relation type or null if this reference is not a `RelationType`.
  `boolean`
  `isReadOnly()`
  Returns the readOnly flag.
  `boolean`
  `isSystem()`
  Returns the system flag.

- ## Method Details

  - ### getId

    UUID getId()
    Returns the unique identifier of the Assigned Characteristic Type Reference.
    Returns:
      the unique identifier of the Assigned Characteristic Type Reference

  - ### getAssignedResourceReference

    NamedResourceReference getAssignedResourceReference()
    Returns the reference to the assigned Characteristic Type. This can be an Attribute Type, Relation Type, Complex Relation Type or Derived Relation Type.
    Returns:
      the reference to the assigned resource

  - ### getAssignedResourcePublicId

    String getAssignedResourcePublicId()
    Returns the public id of the assigned Characteristic Type.
    Returns:
      the public id of the assigned Characteristic Type

  - ### getMinimumOccurrences

    int getMinimumOccurrences()
    Returns how many times the assigned Characteristic must at the minimum be added to the Resource. Zero means no restriction.
    Returns:
      minimum number of occurrences of the Characteristic

  - ### getMaximumOccurrences

    Integer getMaximumOccurrences()
    Returns how many times an assigned Characteristic may be added at most to the Resource. Null means no limit.
    Returns:
      maximum number of occurrences of the Characteristic

  - ### isSystem

    boolean isSystem()
    Returns the system flag. When the system flag is set to true, it means the Characteristic Type cannot be unassigned.
    Returns:
      true if the `AssignedCharacteristicTypeReference` is system

  - ### isReadOnly

    boolean isReadOnly()
    Returns the readOnly flag. When set to true, the value of the assigned Characteristic Type cannot be edited by the user. Only applicable to AttributeType assignment lines.
    Returns:
      true if the characteristic value is read only

  - ### getRelationTypeDirection

    RelationTypeDirection getRelationTypeDirection()
    Returns the direction of the Relation Type or null when this reference isn't a reference to a Relation Type.
    Returns:
      the direction of the Relation Type

  - ### getRelationTypeRestriction

    NamedResourceReference getRelationTypeRestriction()
    Returns the restriction on the target of the relation type or null if this reference is not a `RelationType`.
    Returns:
      the restriction on the target asset type of the `RelationType` or null if not a `RelationType`

  - ### getMatchingLegTypesIds

    List<UUID> getMatchingLegTypesIds()
    Returns the list of `id`s that match the legs of the complex relation or null if this reference is not a `ComplexRelationType`.
    Returns:
      the list of `id`s that match the legs of the complex relation or null if this reference is not a `ComplexRelationType`